//------------------------------------------------------------------------------
// <auto-generated>
//     This code was auto-generated by com.unity.inputsystem:InputActionCodeGenerator
//     version 1.2.0
//     from Assets/Scripts/fire.inputactions
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine.InputSystem;
using UnityEngine.InputSystem.Utilities;

public partial class @fireButton : IInputActionCollection2, IDisposable
{
    public InputActionAsset asset { get; }
    public @fireButton()
    {
        asset = InputActionAsset.FromJson(@"{
    ""name"": ""fire"",
    ""maps"": [
        {
            ""name"": ""fire"",
            ""id"": ""f63b0e2c-9b90-4d0d-aed8-5a7b376811af"",
            ""actions"": [
                {
                    ""name"": ""New action"",
                    ""type"": ""Button"",
                    ""id"": ""93a3cc72-dd80-4a35-b71f-f16692d56eeb"",
                    ""expectedControlType"": ""Button"",
                    ""processors"": """",
                    ""interactions"": """",
                    ""initialStateCheck"": false
                }
            ],
            ""bindings"": [
                {
                    ""name"": """",
                    ""id"": ""f20e8520-7548-440a-9494-b6da09434a12"",
                    ""path"": ""<Mouse>/leftButton"",
                    ""interactions"": """",
                    ""processors"": """",
                    ""groups"": """",
                    ""action"": ""New action"",
                    ""isComposite"": false,
                    ""isPartOfComposite"": false
                }
            ]
        }
    ],
    ""controlSchemes"": []
}");
        // fire
        m_fire = asset.FindActionMap("fire", throwIfNotFound: true);
        m_fire_Newaction = m_fire.FindAction("New action", throwIfNotFound: true);
    }

    public void Dispose()
    {
        UnityEngine.Object.Destroy(asset);
    }

    public InputBinding? bindingMask
    {
        get => asset.bindingMask;
        set => asset.bindingMask = value;
    }

    public ReadOnlyArray<InputDevice>? devices
    {
        get => asset.devices;
        set => asset.devices = value;
    }

    public ReadOnlyArray<InputControlScheme> controlSchemes => asset.controlSchemes;

    public bool Contains(InputAction action)
    {
        return asset.Contains(action);
    }

    public IEnumerator<InputAction> GetEnumerator()
    {
        return asset.GetEnumerator();
    }

    IEnumerator IEnumerable.GetEnumerator()
    {
        return GetEnumerator();
    }

    public void Enable()
    {
        asset.Enable();
    }

    public void Disable()
    {
        asset.Disable();
    }
    public IEnumerable<InputBinding> bindings => asset.bindings;

    public InputAction FindAction(string actionNameOrId, bool throwIfNotFound = false)
    {
        return asset.FindAction(actionNameOrId, throwIfNotFound);
    }
    public int FindBinding(InputBinding bindingMask, out InputAction action)
    {
        return asset.FindBinding(bindingMask, out action);
    }

    // fire
    private readonly InputActionMap m_fire;
    private IFireActions m_FireActionsCallbackInterface;
    private readonly InputAction m_fire_Newaction;
    public struct FireActions
    {
        private @fireButton m_Wrapper;
        public FireActions(@fireButton wrapper) { m_Wrapper = wrapper; }
        public InputAction @Newaction => m_Wrapper.m_fire_Newaction;
        public InputActionMap Get() { return m_Wrapper.m_fire; }
        public void Enable() { Get().Enable(); }
        public void Disable() { Get().Disable(); }
        public bool enabled => Get().enabled;
        public static implicit operator InputActionMap(FireActions set) { return set.Get(); }
        public void SetCallbacks(IFireActions instance)
        {
            if (m_Wrapper.m_FireActionsCallbackInterface != null)
            {
                @Newaction.started -= m_Wrapper.m_FireActionsCallbackInterface.OnNewaction;
                @Newaction.performed -= m_Wrapper.m_FireActionsCallbackInterface.OnNewaction;
                @Newaction.canceled -= m_Wrapper.m_FireActionsCallbackInterface.OnNewaction;
            }
            m_Wrapper.m_FireActionsCallbackInterface = instance;
            if (instance != null)
            {
                @Newaction.started += instance.OnNewaction;
                @Newaction.performed += instance.OnNewaction;
                @Newaction.canceled += instance.OnNewaction;
            }
        }
    }
    public FireActions @fire => new FireActions(this);
    public interface IFireActions
    {
        void OnNewaction(InputAction.CallbackContext context);
    }
}
